#!/usr/bin/env ruby
# ȥ
TITLE = <<-__TITLE__

NArray  RubyDCL ѤƸοư (ʣĹȤνŤ͹碌)
򵭽Ҥ Ruby ץ
(NArray ʬ⥸塼 NumRu::Derivative )

򤤤Ƥ뼰 d^2 u/dt^2 = d^2 u/dx^2
Υ, ֤2٤κʬ (Derivative ⥸塼뻲), 
֤ϥ顼ˡ

__TITLE__

# 
HISTORY = <<-__HISTORY__

  * 2006/06/14 (Yasuhiro MORIKAWA) 赡ǽ
  * 2006/06/13 (Yasuhiro MORIKAWA) 

__HISTORY__

# ԡ饤
COPYRIGHT = <<-__COPYRIGHT__

  Copyright (C) 2006 Yasuhiro MORIKAWA <morikawa@gfd-dennou.org>
                All rights reserved.

__COPYRIGHT__


# 饤֥, ⥸塼ɤ߹
require "numru/dcl"
require "date"
require "optparse"
require "numru/derivative"
include NumRu
include NMath

# ץ
opt = OptionParser.new ; OPTS = {}
ARGV.options{|opt|
  opt.on('-N=VAL','--nm=VAL', "ȿ min:max"
         ) {|v| OPTS[:nm] = v.sub(/^\=/, '')}
  opt.on('--time=VAL', "Υʥåץå"
         ) {|v| OPTS[:snapshot] = v.sub(/^\=/, '').to_f}
  opt.on('-P', '--ps', "PS ե"
         ){|v| OPTS[:ps] = v}
  opt.on('-o=VAL', '--output=VAL', "PS եΥե̾"
         ){|v| OPTS[:output] = v.sub(/^\=/, '')}
  opt.on('--nowait', '--Gw', "˥᡼"
         ){|v| OPTS[:nowait] = v}
  opt.on('--alternate', '--Ga', "Хå󥰥ȥ"
         ){|v| OPTS[:alternate] = v}
  opt.on('--smooth', '--Gaw', "˥᡼ (Хå󥰥ȥ)"
         ){|v| OPTS[:nowait] = v ; OPTS[:alternate] = v}
  opt.on('--history', "ν"
         ){|v| puts HISTORY; exit}
  opt.on('-h','-H','--help', "إ"
         ){|v| puts TITLE ; puts opt ; puts COPYRIGHT; exit }
  opt.parse!
}
minnm = 1 ; maxnm = 3
if OPTS[:nm]
  nm_array = OPTS[:nm].split(':')
  nm_array.collect!{|i| i.to_i}
  minnm = nm_array.min
  minnm = 1 if minnm < 1
  maxnm = nm_array.max
end
iws = OPTS[:ps] ? 2 : 1

#== 
# x 
XMin = 0.0                      # 
XMax = 2.0 * PI                 # 
NX   = 100                      # ֲ
DX   = (XMax - XMin) / ( NX )   # ֹ
x = NArray.float( NX + 1 ).indgen! * DX

# time 
TMin = 0.0                      # 
TMax = 100.0                    # ǽ
DT   = 0.05                     # ֹ
NT   = (TMax - TMin) / ( DT )   # ֥ƥå

# ʥåץå
if OPTS[:snapshot]
  snapshot_time = OPTS[:snapshot] > TMin ? OPTS[:snapshot] : TMin
  snapshot_time = snapshot_time < TMax ? snapshot_time : TMax
end

# ѿν
u      = NArray.sfloat( NX + 1 )                     # u (Ť͹碌)
u_each = NArray.sfloat( NX + 1, maxnm - minnm + 1 )  # u (ñ)
dudt   = NArray.sfloat( NX + 1, maxnm - minnm + 1 )  # du/dt     (ñ)
dudx   = NArray.sfloat( NX + 1, maxnm - minnm + 1 )  # du/dx     (ñ)
d2udx2 = NArray.sfloat( NX + 1, maxnm - minnm + 1 )  # d^2u/dx^2 (ñ)

# ͤȶ
i = 0
(minnm..maxnm).each{|nm|
  u_each[0..NX, i] = sin(x * nm)
  u_each[ 0, i] = 0.0
  u_each[NX, i] = 0.0
  u = u + u_each[0..NX, i]
  i += 1
}

#== ν
# ޥɥ饤󥪥ץ-psޤޤƤPSե(gropn(2)),
# ʤХɥ򳫤(gropn(1))

DCL::swlset('lalt',  true)  if OPTS[:alternate] # ΢
DCL::swlset('lwait', false) if OPTS[:nowait]    # ˥᡼
DCL::gropn(iws)

# Ȥκ, ǾͤŤ͹碌Ȥοǻ
frame_range = maxnm - minnm + 1

#== ֥롼
#
(0..NT).each{|t|

  time = t * DT

  now_draw = !OPTS[:snapshot]
  if OPTS[:snapshot]
    now_draw = (time - snapshot_time).abs < DT
  end

  #== 
  if now_draw
    DCL::grfrm
    DCL::grswnd(XMin, XMax, - frame_range, frame_range)
                                    # κɸ
    DCL::ussttl('X', '1', 'U', '1')   # ȥ
    DCL::usgrph(x, u)                 # ͤ
    DCL::uxsttl('b', 
                "nm=#{minnm}:#{maxnm}, time=#{sprintf("%.3f", time)}",
                0.0)                  # ˲ɲ

    break if OPTS[:snapshot]
  end

  u = 0.0 # Ť͹碌ν

  #== ȿΥ롼
  #
  i = 0
  (minnm..maxnm).each{|nm|
    dudx[0..NX, i] = Derivative::cderiv(u_each[0..NX, i], x, 0)
    d2udx2[0..NX, i] = Derivative::cderiv(dudx[0..NX, i], x, 0)
    dudt[0..NX, i] = dudt[0..NX, i] + d2udx2[0..NX, i] * DT
                                # {du/dt(t+t) - du/dt(t)} / t = d^2 u/dx^2
    u_each[0..NX, i] = u_each[0..NX, i] + dudt[0..NX, i] * DT
                                # {u(t+t) - u(t)} / t = du/dt
    u_each[ 0, i] = 0.0 ; u_each[NX, i] = 0.0 # 
    dudt[ 0, i]   = 0.0 ; dudt[NX, i]   = 0.0 # 

    u = u + u_each[0..NX, i]

    i += 1

  }

}
DCL::grcls

# ̾ѹ
if OPTS[:ps]
  if OPTS[:output]
    fname = OPTS[:output]
    File.rename("dcl.ps", fname)
    print "#{fname} is output.\n"
  else
    print "dcl.ps is output.\n"
  end
end
